<?php
declare (strict_types=1);
namespace library\utils\Sms;
// +----------------------------------------------------------------------
// | [ WE CAN DO IT MORE SIMPLE  ]
// +----------------------------------------------------------------------
// | Copyright (c) 2018-2020 rights reserved.
// +----------------------------------------------------------------------
// | Author: TABLE ME
// +----------------------------------------------------------------------
// | Date: 2020-08-31 15:18
// +----------------------------------------------------------------------

use app\model\api\SmsSend;
use app\model\api\SmsTpl;

class AliSms {

    /**
     * 转义的模板信息
     * @param $content
     * @return mixed
     */
    function SmsTmpParam($content) {
        $data = func_get_args();
        foreach ($data[1] as $k => $v) {
            $content = str_replace('${' . $k . '}', $v, $content);
        }
        return $content;
    }

    /**
     * 发送模板的数据
     * @param type $tpl
     * @param type $code
     */
    function SmsSendTmplete($tel, $code,$sassid, $array = []) {
        $sData = SmsTpl::where("code",$code)->find();
        $r = false;
        $error = '';
        $req = null;
        if (!empty($sData)) {
            $req = $this->SmsSend($tel, $code, $array);
            if (!empty($req['Code'])  && $req['Code'] == 'OK') {
                $r = true;
            } else {
                $error = $req['Message'];

            }
            $datax['mobile'] = $tel;
            $datax['content'] = $this->SmsTplParm($sData['content'], $array);
            $datax['time'] = time();
            $datax['code'] = $code;
            $datax['sassid'] = $sassid;
            if ($r) {
                $datax['is_success'] = 1;
            } else {
                $datax['is_success'] = -1;
                $datax['error'] = $error;
            }
            ( new SmsSend)->insert($datax);
        }
        return $req;
    }

    /**
     * 发送短信
     * @param type $tel 手机号码
     * @param type $sms_templ 模板名称
     * @param type $smsParam 模板参数
     */
    function SmsSend($tel, $sms_templ, $smsParam = []) {
        $config = config('sms');
        foreach ($smsParam as $k => $v) {
            $smsParam[$k] = (string) $v;
        }

        $params =[];
        $accessKeyId = $config['accessKeyId'];
        $accessKeySecret = $config['accessKeySecret'];

        // fixme 必填: 短信接收号码
        $params["PhoneNumbers"] = $tel;

        // fixme 必填: 短信签名，应严格按"签名名称"填写，请参考: https://dysms.console.aliyun.com/dysms.htm#/develop/sign
        $params["SignName"] = $config['sign_name'];

        // fixme 必填: 短信模板Code，应严格按"模板CODE"填写, 请参考: https://dysms.console.aliyun.com/dysms.htm#/develop/template
        $params["TemplateCode"] = $sms_templ;

        // fixme 可选: 设置模板参数, 假如模板中存在变量需要替换则为必填项
        $params['TemplateParam'] = $smsParam;

        // *** 需用户填写部分结束, 以下代码若无必要无需更改 ***
        if (!empty($params["TemplateParam"]) && is_array($params["TemplateParam"])) {
            $params["TemplateParam"] = json_encode($params["TemplateParam"], JSON_UNESCAPED_UNICODE);
        }

        $content = $this->request($accessKeyId, $accessKeySecret, "dysmsapi.aliyuncs.com", array_merge(
            $params,
            [   "RegionId" => "cn-hangzhou",
                "Action" => "SendSms",
                "Version" => "2017-05-25"
            ]
        ));


        $resp = json_decode(json_encode($content), true);

        return $resp;
    }



    /**
     * 生成签名并发起请求
     *
     * @param $accessKeyId string AccessKeyId (https://ak-console.aliyun.com/)
     * @param $accessKeySecret string AccessKeySecret
     * @param $domain string API接口所在域名
     * @param $params array API具体参数
     * @param $security boolean 使用https
     * @return bool|\stdClass 返回API接口调用结果，当发生错误时返回false
     */
    public function request($accessKeyId, $accessKeySecret, $domain, $params, $security = false) {


        $apiParams = array_merge(array(
            "SignatureMethod" => "HMAC-SHA1",
            "SignatureNonce" => uniqid((string) mt_rand(0, 0xffff) , true),
            "SignatureVersion" => "1.0",
            "AccessKeyId" => $accessKeyId,
            "Timestamp" => gmdate("Y-m-d\TH:i:s\Z"),
            "Format" => "JSON",
        ), $params);
        ksort($apiParams);

        $sortedQueryStringTmp = "";
        foreach ($apiParams as $key => $value) {
            $sortedQueryStringTmp .= "&" . $this->encode($key) . "=" . $this->encode($value);
        }

        $stringToSign = "GET&%2F&" . $this->encode(substr($sortedQueryStringTmp, 1));

        $sign = base64_encode(hash_hmac("sha1", $stringToSign, $accessKeySecret . "&", true));

        $signature = $this->encode($sign);

        $url = ($security ? 'https' : 'http') . "://{$domain}/?Signature={$signature}{$sortedQueryStringTmp}";

        try {
            $content = $this->fetchContent($url);
            return json_decode($content);
        } catch (\Exception $e) {
            return false;
        }
    }

    private function encode($str)
    {
        $res = urlencode($str);
        $res = preg_replace("/\+/", "%20", $res);
        $res = preg_replace("/\*/", "%2A", $res);
        $res = preg_replace("/%7E/", "~", $res);
        return $res;
    }

    private function fetchContent($url) {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_TIMEOUT, 5);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_HTTPHEADER, array(
            "x-sdk-client" => "php/2.0.0"
        ));
        if(substr($url, 0,5) == 'https') {
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
            curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
        }
        $rtn = curl_exec($ch);

        if($rtn === false) {
            trigger_error("[CURL_" . curl_errno($ch) . "]: " . curl_error($ch), E_USER_ERROR);
        }
        curl_close($ch);
        return $rtn;
    }

}
